# fideo-api
Fideo Intelligence offers an identity intelligence product that protects the public good.
- [Fideo Privacy Policy](https://www.fideo.ai/privacy-policy/)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.4
- Package version: 1.0.4
- Generator version: 7.8.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import fideo_api
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import fideo_api
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import fideo_api
from fideo_api.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.fideo.ai
# See configuration.py for a list of all supported configuration parameters.
configuration = fideo_api.Configuration(
    host = "https://api.fideo.ai"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization: bearerAuth
configuration = fideo_api.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with fideo_api.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = fideo_api.SignalsApi(api_client)
    v = 'v_example' # str |  (optional)
    multi_field_req_with_options = fideo_api.MultiFieldReqWithOptions() # MultiFieldReqWithOptions |  (optional)

    try:
        api_response = api_instance.signals_post(v=v, multi_field_req_with_options=multi_field_req_with_options)
        print("The response of SignalsApi->signals_post:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling SignalsApi->signals_post: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.fideo.ai*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SignalsApi* | [**signals_post**](docs/SignalsApi.md#signals_post) | **POST** /signals | 
*VerifyApi* | [**verify_post**](docs/VerifyApi.md#verify_post) | **POST** /verify | 


## Documentation For Models

 - [Alias](docs/Alias.md)
 - [Demographics](docs/Demographics.md)
 - [Economic](docs/Economic.md)
 - [Education](docs/Education.md)
 - [EducationDate](docs/EducationDate.md)
 - [Email](docs/Email.md)
 - [Employment](docs/Employment.md)
 - [EmploymentDate](docs/EmploymentDate.md)
 - [Evidence](docs/Evidence.md)
 - [IPCountry](docs/IPCountry.md)
 - [IpAddress](docs/IpAddress.md)
 - [Location](docs/Location.md)
 - [LocationReq](docs/LocationReq.md)
 - [LocationType](docs/LocationType.md)
 - [MultiFieldReq](docs/MultiFieldReq.md)
 - [MultiFieldReqWithOptions](docs/MultiFieldReqWithOptions.md)
 - [Name](docs/Name.md)
 - [NameWithAlias](docs/NameWithAlias.md)
 - [PersonNameReq](docs/PersonNameReq.md)
 - [Phone](docs/Phone.md)
 - [Photo](docs/Photo.md)
 - [ScoreDetails](docs/ScoreDetails.md)
 - [SignalsPost200Response](docs/SignalsPost200Response.md)
 - [SignalsResponseV0](docs/SignalsResponseV0.md)
 - [SignalsResponseV20240424](docs/SignalsResponseV20240424.md)
 - [SocialProfileDetails](docs/SocialProfileDetails.md)
 - [SocialProfileReq](docs/SocialProfileReq.md)
 - [SocialProfileUrls](docs/SocialProfileUrls.md)
 - [VerifyResponse](docs/VerifyResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearerAuth"></a>
### bearerAuth

- **Type**: Bearer authentication


## Author

support@fideo.ai


